; These have been embeded in the C source file (jcpplisp.cpp).
;						1 July 2017

;-----------------------------------------------------------------------------------------------------------------
(defun caaaar (x) (car (caaar x)))

(defun caaadr (x) (car (caadr x)))

(defun caaar (x) (car (caar x)))

(defun caadar (x) (car (cadar x)))

(defun caaddr (x) (car (caddr x)))

(defun caadr (x) (car (cadr x)))

(defun caar (x) (car (car x)))

(defun cadaar (x) (car (cdaar x)))

(defun cadadr (x) (car (cdadr x)))

(defun cadar (x) (car (cdar x)))

(defun caddar (x) (car (cddar x)))

(defun cadddr (x) (car (cdddr x)))

(defun caddr (x) (car (cddr x)))

(defun cadr (x) (car (cdr x)))

;----------------------------------------------
(defun cdaaar (x) (cdr (caaar x)))

(defun cdaadr (x) (cdr (caadr x)))

(defun cdaar (x) (cdr (caar x)))

(defun cdadar (x) (cdr (cadar x)))

(defun cdaddr (x) (cdr (caddr x)))

(defun cdadr (x) (cdr (cadr x)))

(defun cdar (x) (cdr (car x)))

(defun cddaar (x) (cdr (cdaar x)))

(defun cddadr (x) (cdr (cdadr x)))

(defun cddar (x) (cdr (cdar x)))

(defun cdddar (x) (cdr (cddar x)))

(defun cddddr (x) (cdr (cdddr x)))

(defun cdddr (x) (cdr (cddr x)))

(defun cddr (x) (cdr (cdr x)))

;----------------------------------------------------

(defun second (x) (nth 1 x))

(defun third (x) (nth 2 x))

(defun fourth (x) (nth 3 x))

(defun fifth (x) (nth 4 x))

(defun sixth (x) (nth 5 x))

(defun seventh (x) (nth 6 x))

(defun eighth (x) (nth 7 x))

(defun ninth (x) (nth 8 x))

(defun tenth (x) (nth 9 x))

;------------------------------------------------

; }NSETF
(defmacro setf (x? y?)
    (cond
	((symbolp x?) `(setq ,x? ,y?))
	((and (not (atom x?)) (eq (car x?) 'car) (not (atom (cdr x?))))
	 `(progn (rplaca ,(car (cdr x?)) ,y?) ,y?) )
	((and (not (atom x?)) (eq (car x?) 'cdr) (not (atom (cdr x?))))
	 `(progn (rplacd ,(car (cdr x?)) ,y?) ,y?) )
	((and (not (atom x?)) (eq (car x?) 'nth) (not (atom (cdr x?))) (not (atom (cdr (cdr x?)))))
	 `(progn (rplaca (nthcdr ,(car (cdr x?)) ,(car (cdr (cdr x?)))) ,y?) ,y?) )
	((and (not (atom x?)) (not (atom (cdr x?))) (find-nth-name (car x?)))
	 `(progn (rplaca (nthcdr ,(cdr (find-nth-name (car x?))) ,(car (cdr x?))) ,y?) ,y?) )
	((and (not (atom x?)) (not (atom (cdr x?))) (find-a-name (car x?)))
	 `(progn (rplaca ,(cons (cdr (find-a-name (car x?))) (cdr x?)) ,y?) ,y?) )
	((and (not (atom x?)) (not (atom (cdr x?))) (find-d-name (car x?)))
	 `(progn (rplacd ,(cons (cdr (find-d-name (car x?))) (cdr x?)) ,y?) ,y?) )
	((and (not (atom x?)) (eql (car x?) 'gethash) (not (atom (cdr x?))) (not (atom (cdr (cdr x?)))))
	    (list 'setf-hash (car (cdr x?)) (car (cdr (cdr x?))) y?)
	)
	((and (consp x?) (eql (car x?) 'aref))
	 (list 'progn (list 'rplaca (cons 'pre-aref (cons y? (cdr x?))) y?) y?) )
	(t nil)
    )
)

(defun setf-hash (k i v)
  (let ((org-i i))
    (setq i (cdr (cdr org-i)))
    (let ((pair (apply #'assoc (list k i :test (car (cdr org-i))))))
	(cond
	    ((null pair) (rplacd (last org-i) (list (cons k v))) v)
	    (t (rplacd pair v) v) ) ) ) )

(defun find-nth-name (name)
    (assoc name '((first . 0) (second . 1) (third . 2) (fourth . 3) (fifth . 4) (sixth . 5)
		  (seventh . 6) (eighth . 7) (ninth . 8) (tenth . 9) ) ) )

; ֐NTHCDR
(defun nthcdr (n lst)
    (cond
	((> 0 n) nil)
	((atom lst) lst)
	((zerop n) lst)
	(t (nthcdr (1- n) (cdr lst))) ) )

; ֐ASSOC
(defun assoc (x alist &rest r)
  (let ((test #'eq))
    (if (and (>= (length r) 2) (eq :test (car r))) (setq test (car (cdr r))))
    (cond
	((atom alist) nil)
	((apply test (list x (car (car alist)))) (car alist))
	(t (apply #'assoc (if (>= (length r) 2) (list x (cdr alist) (car r) (car (cdr r))) (list x (cdr alist))))) ) ) )

(defun find-a-name (name)
    (assoc name '(
(caaaar . caaar) (caaadr . caadr) (caaar . caar) (caadar . cadar) (caaddr . caddr) (caadr . cadr) (caar . car)
(cadaar . cdaar) (cadadr . cdadr) (cadar . cdar) (caddar . cddar) (cadddr . cdddr) (caddr . cddr) (cadr . cdr)
    ) ) )

(defun find-d-name (name)
    (assoc name '(
(cdaaar . caaar) (cdaadr . caadr) (cdaar . caar) (cdadar . cadar) (cdaddr . caddr) (cdadr . cadr) (cdar . car)
(cddaar . cdaar) (cddadr . cdadr) (cddar . cdar) (cdddar . cddar) (cddddr . cdddr) (cdddr . cddr) (cddr . cdr)
    ) ) )

;----- hash-table functions---------------------------------------------------------------------------------------

(defun make-hash-table (&rest b)
    (cond
	((null b) (list 'hash-table 'eql))
	((eql (car b) :test) (list 'hash-table (car (cdr b))))
	(t (error "G[: @G[")) ) )

(defun gethash (key ins)
    (let ((cnd))
	(if (or (atom ins) (not (eql (car ins) 'hash-table)) (atom (cdr ins)) (not (atom (setq cnd (car (cdr ins))))) )
	    (error "G[: nbVe[uł͂܂")
	    (progn
		(setq ins (cdr (cdr ins)))
		(loop
		    (if (null ins) (return (values nil nil)))
		    (if (atom (car ins)) (error "G[: nbVe[uĂ܂"))
		    (if (funcall cnd key (car (car ins))) (return (values (cdr (car ins)) t)))
		    (setq ins (cdr ins))
		)
	    )
	)
    )
)

(defun hash-table-count (ins)
    (if (or (atom ins) (not (eql (car ins) 'hash-table)) (atom (cdr ins)))
	(error "G[: nbVe[uł͂܂")
	(length (cdr (cdr ins)))
    )
)

(defun remhash (key ins)
    (if (or (atom ins) (not (eql (car ins) 'hash-table)) (atom (cdr ins)))
	(error "G[: nbVe[uł͂܂")
	(let ((previns) (test (car (cdr ins))))
	    (setq previns (cdr ins))
	    (setq ins (cdr (cdr ins)))
	    (loop
		(if (null ins) (return nil))
		(if (funcall test key (car (car ins)))
		    (progn
			(rplacd previns (cdr ins))
			(return t)
		    )
		)
		(setq previns ins)
		(setq ins (cdr ins))
	    )
	)
    )
)

(defun maphash (func hash)
    (setq hash (cdr (cdr hash)))
    (loop
	(if (null hash) (return nil))
	(funcall func (car (car hash)) (cdr (car hash)))
	(setq hash (cdr hash)) ) )

;--------------------------------------------------
; ֐LAST
(defun last (x)
    (cond
	((atom x) x)
	((= (length x) 1) x)
	(t (last (cdr x))) ) )

; }NCASE
(defmacro case (key &rest body)
    `(cond
	,@(make-case key body) ) )

(defun make-case (key body)
    (cond
	((null body) nil)
	((eq (car (car body)) 'otherwise) (cons `(t ,@(cdr (car  body))) (make-case key (cdr body))))
	((atom (car (car body))) (cons `((eql ,key ',(car (car body))) ,@(cdr (car body))) (make-case key (cdr body))))
	(t (cons `((member ,key ',(car (car body))) ,@(cdr (car body))) (make-case key (cdr body)))) ) )

; end of file

